#include "config.h"
#include "jtag.h"


// FIXME: This could be done much easier with a simple 2d array of 
//        bit descriptors ala action[from][to]. 

void JTagTAP::TapMoveTo(JtagState to)
{
	// Current state of the waveform bits. 
	// This is a hack...
	uint8 state=0;
#define SET_TMS_HIGH()  state|=TMS
#define SET_TMS_LOW()   state&=~TMS
#define SET_TDI_HIGH()  state|=TDI
#define SET_TDI_LOW()   state&=~TDI
#define PULSE_TCK()     clock(state)
	
	switch(curr_state)
	{
		case TEST_LOGIC_RESET:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					break;
				case RUN_TEST_IDLE:
					SET_TMS_LOW();
					PULSE_TCK();
					break;
				case SELECT_DR_SCAN:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PUASE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case RUN_TEST_IDLE:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case SELECT_DR_SCAN:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					break;
				case CAPTURE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case CAPTURE_DR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					break;
				case SHIFT_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				default:  assert(0);
			}
			break;
		case SHIFT_DR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case EXIT1_DR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					break;
				case PAUSE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case PAUSE_DR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				default:  assert(0);
			}
			break;
		case EXIT2_DR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: UPDATE_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case UPDATE_DR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case SELECT_IR_SCAN:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					break;
				case CAPTURE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case CAPTURE_IR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					break;
				case SHIFT_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case SHIFT_IR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case EXIT1_IR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: UPDATE_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					break;
				case PAUSE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case PAUSE_IR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case EXIT2_IR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_LOW();
					PULSE_TCK();	// now: SHIFT_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					break;
				case UPDATE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: UPDATE_IR
					break;
				default:  assert(0);
			}
			break;
		case UPDATE_IR:
			switch(to)
			{
				case TEST_LOGIC_RESET:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();
					PULSE_TCK();	// now: TEST_LOGIC_RESET
					break;
				case RUN_TEST_IDLE:
					SET_TMS_LOW();
					PULSE_TCK();	// now: RUN_TEST_IDLE
					break;
				case SELECT_DR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					break;
				case CAPTURE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					break;
				case SHIFT_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_DR
					break;
				case EXIT1_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					break;
				case PAUSE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					break;
				case EXIT2_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_DR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_DR
					break;
				case UPDATE_DR:
					SET_TMS_HIGH();
					PULSE_TCK();	// now: SELECT_DR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_DR
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: UPDATE_DR
					break;
				case SELECT_IR_SCAN:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					break;
				case CAPTURE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					break;
				case SHIFT_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();
					PULSE_TCK();	// now: SHIFT_IR
					break;
				case EXIT1_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					break;
				case PAUSE_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					break;
				case EXIT2_IR:
					SET_TMS_HIGH();
					PULSE_TCK();
					PULSE_TCK();	// now: SELECT_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: CAPTURE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT1_IR
					SET_TMS_LOW();
					PULSE_TCK();	// now: PAUSE_IR
					SET_TMS_HIGH();
					PULSE_TCK();	// now: EXIT2_IR
					break;
				case UPDATE_IR:
					break;
				default:  assert(0);
			}
			break;
		default:  assert(0);
	}
	
	curr_state=to;
}
